# -*- coding: utf-8 -*-
"""
/***************************************************************************
 travauxDialog
                                 A QGIS plugin
 travaux
 Generated by Plugin Builder: http://g-sherman.github.io/Qgis-Plugin-Builder/
                             -------------------
        begin                : 2022-08-22
        git sha              : $Format:%H$
        copyright            : (C) 2022 by colas
        email                : colas.geier@cen-isere.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""

import os

from qgis.PyQt import uic
from qgis.PyQt import QtWidgets
from datetime import datetime as dt

# This loads your .ui file so that PyQt can populate your plugin with the elements from Qt Designer
FORM_CLASS, _ = uic.loadUiType(os.path.join(
    os.path.dirname(__file__), 'travaux_dialog_base.ui'))


class travauxDialog(QtWidgets.QDialog, FORM_CLASS):
    def __init__(self, parent=None):
        """Constructor."""
        super(travauxDialog, self).__init__(parent)
        # Set up the user interface from Designer through FORM_CLASS.
        # After self.setupUi() you can access any designer object by doing
        # self.<objectname>, and you can use autoconnect slots - see
        # http://qt-project.org/doc/qt-4.8/designer-using-a-ui-file.html
        # #widgets-and-dialogs-with-auto-connect
        self.setupUi(self)

    def InitFormulaire(self, con):
        
        # self.date_debut.clear()
        # self.annee_trav.clear()
        self.date_debut.setDate(dt.now().date())
        self.annee_trav.setDate(dt.now().date())
        # GET site_code
        rq_site = "SELECT DISTINCT ON (code_site) id,code_site FROM sites.c_sites_zonages ORDER BY code_site;"
        cur = con.cursor()
        cur.execute(rq_site)
        res_site = cur.fetchall()
        res_site = dict(res_site)

        rq_pregest = "SELECT DISTINCT code_n1,niveau1 FROM ref_travaux.cr_type_gestion ORDER BY 1"
        cur = con.cursor()
        cur.execute(rq_pregest)
        res_pregest = cur.fetchall()
        res_pregest = dict(res_pregest)
        lst_pregest = [i + ' - ' + res_pregest[i] if i is not None else res_pregest[i] for i in res_pregest]

        rq_gest = "SELECT id_gestion,legende FROM ref_travaux.cr_type_gestion ORDER BY 1"
        cur = con.cursor()
        cur.execute(rq_gest)
        res_gest = cur.fetchall()
        res_gest = dict(res_gest)

        rq_prestataire = "SELECT id_presta,lib_presta FROM ref_travaux.cr_type_prestataire"
        cur = con.cursor()
        cur.execute(rq_prestataire)
        res_prestataire = cur.fetchall()
        res_prestataire = dict(res_prestataire)

        rq_prestation = "SELECT id, val_mat FROM ref_travaux.cr_type_prestation ORDER BY 1"
        cur = con.cursor()
        cur.execute(rq_prestation)
        res_prestation = cur.fetchall()
        res_prestation = dict(res_prestation)

        rq_valmat = "SELECT id, val_mat FROM ref_travaux.cr_valorisation_matiere ORDER BY 1"
        cur = con.cursor()
        cur.execute(rq_valmat)
        res_valmat = cur.fetchall()
        res_valmat = dict(res_valmat)

        # self.id_site.addItems(res_site.values())
        # self.id_gestion.addItems([None,*res_gest.values()])
        self.pre_gestion.addItems([None,*lst_pregest])
        self.id_presta.addItems([None,*res_prestataire.values()])
        self.prestation.addItems([None,*res_prestation.values()])
        self.val_mat.addItems([None,*res_valmat.values()])

